;(setq lasm_tok *t*)
;    ,   ?

;(load "lasm_misc")

(setq lasm-line   *nil*)
  ; parsed line (list): label,command,arglist
(setq lasm-argc   0)  ; # of args in lasm-line
(setq lasm-argv   *nil*) ; list of args
(setq lasm-label  *nil*)
(setq lasm-cmd    *nil*)
(setq lasm-line-n 0)


;  -:
;     :
;    ( NIL)
;   - (  ,  *MACRO)
;    ,  ,    ,  .
;        --  
;    (  DEFB,DB,DEFW,DW,DEFS,DS,DEFM)
;     ,    
;   lasm-line, lasm-argc

;    .
;  --   ( )  NIL
;  -- 
;  -- 
;    BOTTOM
;         
;   .  "",     
;    .
; ,         ( )
;  --  (   )
;   --    NIL
(defun asm-tokenize (str | ostr res x
  ;  
    del-1st-char add-1st-char skip-spaces collect-id collect-label
    skip-quoted
  )
  (setq ostr str  str (smart-locase str)
        lasm-argc 0  lasm-argv *nil*  lasm-label *nil*  lasm-cmd *nil*)
  ; x:  , 
  ; ostr:   ( BOTTOM)

  (defun add-1st-char ()  (setq x (|| x (lo-case str))) )
  (defun del-1st-char ()  (setq str (str-mid str 2)) )

  (defun skip-spaces ()  (setq str (trim-left str)) )

  (defun collect-id ()
    (setq x 2)
    (while (land (<= x (length str))  (is-alphanum (nth str x)))
      (setq x (incr x)))
    (setq x (str-mid str 1 (decr x)))
    (setq str (str-mid str (incr (length x))))
    (skip-spaces) x
  )

  (defun collect-label (| hasdot)
    (if (= (nth str 1) 46)  ; ?
      (begin
        (del-1st-char)  ;  
        (if (not (is-alphanum (nth str 1))) (bad-syntax "invalid local label"))
        (setq hasdot *t*)
      )
     (setq hasdot *f*)
    )
    (collect-id)
    (if (is-colon (nth str 1)) (del-1st-char))  ;  ":"
    (if hasdot (setq x (|| "." x)))
    x
  )

  (defun skip-quoted ()
    ; skip quoted string
    (setq x (incr x)) ; skip "
    (while (land (<= x (length str))  (<> (nth str x) 34))
      (setq x (incr x))
    )
  )


  (if (empty-str? str) (return *nil*))

  ;  
  (for (setq x 1) (<= x (length str)) (setq x (incr x))
    (if
      (= (nth str x) 59)
        (break (setq str (str-mid str 1 (decr x))))
      (is-quote (nth str x)) (skip-quoted)
    )
  )
  (if (empty-str? str) (return *nil*))

  ;   
  (setq str (trim-right str))
  (if (empty-str? str) (return *nil*))

  ;      ,  
  (if
    (lor (is-alpha (nth str 1)) (= (nth str 1) 46))  ;  
      (setq res (cons (collect-label) res)  lasm-label x)
    (setq res (cons *nil* res))
  )
  (skip-spaces)

  (if (empty-str? str) (return *nil*))
  (if
    (is-alpha (nth str 1)) (begin
      ;    
      (setq res (cons (collect-id) res)  lasm-cmd x) ; 
      ;  (    )
      ;     
      (for (setq x 1) (<= x (length str)) (setq x (incr x))
        (if
          (is-comma (nth str x))
            ;  
            (begin
              (setq lasm-argc (incr lasm-argc))
              (setq res (cons (trim (str-mid str 1 (decr x))) res)) ;  
              ;      "" 
              (setq str (trim-left (str-mid str (incr x)))) ;   ,  
              (setq x 0)
            )
          (is-quote (nth str x)) (skip-quoted)
        )
      )
      (if (not-empty-str? str)
            (setq res (cons str res)  lasm-argc (incr lasm-argc))
      )
    )
    (not-empty-str? str) (bad-syntax (|| "invalid asm string: \"" ostr "\""))
  )
  (setq res (reverse res))

  (setq lasm-line res)
  (if (> lasm-argc 0)
    (setq lasm-argv (cddr res))
  )
  ;(lprintln "lab:" lasm-label)
  ;(lprintln "alist:" *alist*)
  ;(dump-alist)
  res
)
